C**************************************************************
      Function WriteLogFile (unit,logfile,ProgramName,Message)
C==============================================================
C 
C
C
      IMPLICIT None
C
C Declare Character Type Variables ...
C
      Character 
     > SetLogFileName*30,     !Name of function for file name
     > FileName*30,           !Name of log file
     > DateTime*16,           !Time and Date String.
     > NewMessage*80,         !Message written to file
     > NewProgramName*20      !Program name written to file
C
      Character*(*) 
     > Message,               ! message entered by user.
     > ProgramName,           ! Program name entered by user
     > logfile                ! Name of the logfile to be used
    
C
C Declare Logical Type Variables ...
C
      LOGICAL
     > THERE                  ! Existence of Files
C
C Declare Integer Type Variables ...
C
      Integer
     > MaximumRecords,        ! Maximum number of records
     > ios,                   ! Error Status on file open
     > unit,                  ! Random Access File unit
     > CurrentRecord,         ! Number of next available record
     > RecordCount,           ! Total number of records written
     > WriteLogFile,          ! Name of Function
     > valid                  ! Valid length for logfile name
C
C
C Setup Local Variable Data Statements
C
      valid = LEN(logfile)
      FileName = SetLogFileName(unit, 'x')
      
C
C Change name of log file if valid logfile name is entered
C
      if (valid .GT. 5) then
          FileName = SetLogFileName(unit, logfile)
      endif
C
C
C Check to see of there is a log file on the filing system
C
      INQUIRE (FILE=FileName, EXIST=THERE)
C
C
C If log file does not exit... Call CreateLogFile....
C check again to see if the log file exist.... 
C
        if  (.NOT. THERE)  then
             CALL CreateLogFile (unit, -1)
             INQUIRE (FILE=FileName, EXIST=THERE)
C 
C If file was created successful open it..
C
             IF (THERE) THEN          
              OPEN (UNIT=unit, 
     >              FILE=FileName, 
     >              ACCESS='DIRECT', 
     >              RECL=125, 
     >              IOSTAT=ios, 
     >              STATUS='OLD',
     >              FORM='UNFORMATTED')
C
C if file was not created set WriteLogFile to Zero to indicate
C and error and return to main program. 
                 ELSE           
                       WriteLogFile = 0
                       Return
              END IF
      ELSE
C
C Log file Existed on disk. Open it for writing....
C
          OPEN (UNIT=unit, 
     >          FILE=FileName, 
     >          ACCESS="DIRECT", 
     >          RECL=125, 
     >          IOSTAT=ios, 
     >          STATUS='OLD',
     >          FORM='UNFORMATTED')
       END IF
C
C
C
C Read the Header Record from the Log file....
C
      READ (UNIT=unit, REC=1) 
     >      MaximumRecords, 
     >      CurrentRecord, 
     >      RecordCount
C
C Get Time and Date from System and Place in string Variable
C
      call timdat(DateTime)
C
C
C Check for errors in user input to function... Program name must
C be greater than three characters or error message is written to
C file. 
C
       if (LEN(ProgramName) .LT. 3) then
           NewMessage = ' '
           NewProgramName = '*****Error********'
           WRITE(UNIT=unit, REC=CurrentRecord) 
     >           DateTime, 
     >           NewProgramName, 
     >           NewMessage
C
C Character Length of Message must be greater than ten (10)
      else if (LEN(Message) .LT. 20) then
               NewProgramName = ProgramName
               NewMessage = 'Program did not indicate proper error
     >                       message'
         WRITE(UNIT=unit,  REC=CurrentRecord) 
     >         DateTime, 
     >         NewProgramName, 
     >         NewMessage
C
C There were not errors in the input variables and message 
C user entered is written to the log file.
C
      else
        NewProgramName = ProgramName
        NewMessage = Message
        WRITE(UNIT=unit, REC=CurrentRecord) 
     >        DateTime, 
     >        NewProgramName, 
     >        NewMessage
      END IF
C
C
C If RecordCount is less than Maximum: this indicates that 
C not all records have been written at least one. advance
C RecordCount by one.  
C
      if (RecordCount .LT. MaximumRecords) then
          RecordCount = RecordCount + 1
      end if
C
C Advance CurrentRecord by one and check to see if it 
C exceeds the maximum plus one.  If maximum records has been
C written reset current record to the first record after the
C header file.

      CurrentRecord = CurrentRecord + 1
      if (CurrentRecord .GT. (MaximumRecords + 1)) then
          CurrentRecord = 2
      end if
C
C ReWrite Updated Header File Back to Random Access File...
C 
      WRITE(UNIT=unit, REC=1) 
     >      MaximumRecords, 
     >      CurrentRecord, 
     >      RecordCount
C
C Close Random Access file and set WriteLogFile to indicate that
C Functions was successful and return to main program.
C
      close(unit)
      WriteLogFile = 1
      RETURN
C
      END 
     
     
