      SUBROUTINE COFITN(X,Y,NPTS,COEFS)
C $ SUBROUTINE COFITN(X,Y,NPTS,COEFS)          (BTR)
C $ OBTAINS THE COEFFICIENTS OF THE POLYNOMIAL, OF DEGREE NPTS-1,
C $   PASSING THROUGH THE GIVEN X,Y POINTS.  THE METHOD OF DIVIDED
C $   DIFFERENCES IS USED.
C $ X = (R) INPUT   ARRAY OF X-VALUES
C $ Y = (R) INPUT   ARRAY OF Y-VALUES
C $ NPTS = (I) INPUT  NUMBER OF (X,Y) PAIRS, MAXIMUM VALUE IS 20
C $ COEFS = (R) OUTPUT  ARRAY OF COEFFICIENTS IN ORDER OF ASCENDING
C $       POWERS
C $$ COFITN=VAS,COMPUTATION
C **** VERSION OF 12 DEC 85
C
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*4 X,Y
      DIMENSION DD(20,20),X(1),Y(1),COEFS(1),TEMP(20),ACCUM(20)
      DO 100 J=1,NPTS
  100 DD(1,J)=Y(J)
      N=NPTS-1
      I=2
      GO TO 130
  110 DO 120 J=1,N
      DD(I,J)=(DD(I-1,J+1)-DD(I-1,J))/(X(JH)-X(JL))
      JH=JH+1
  120 JL=JL+1
      N=N-1
      IF(N.EQ.0) GO TO 140
      I=I+1
  130 JL=1
      JH=JL+I-1
      GO TO 110
  140 DO 150 J=1,20
  150 ACCUM(J)=0.
      DO 160 J=1,NPTS
  160 COEFS(J)=0.
      ACCUM(1)=1.
      N=NPTS
      I=2
  170 COEF=-X(N)
      DO 180 J=1,20
  180 TEMP(J)=COEF*ACCUM(J)
      J=19
  190 ACCUM(J+1)=ACCUM(J)
      J=J-1
      IF(J.NE.0) GO TO 190
      ACCUM(1)=0.
      DO 200 J=1,20
  200 ACCUM(J)=ACCUM(J)+TEMP(J)
      NM1=N-1
      DO 210 J=1,NPTS
  210 COEFS(J)=COEFS(J)+DD(I,NM1)*ACCUM(J)
      I=I+1
      N=N-1
      IF(N.NE.1) GO TO 170
      COEFS(1)=COEFS(1)+Y(NPTS)
      RETURN
      END
