      SUBROUTINE GESPRO(ICLIM,NOSFC,MDNO)
C $ SUBROUTINE GESPRO(ICLIM,NOSFC,MDNO)           (CMH)
C $ GESPRO - Get profile from VASGSS grid, climatology grid, or MD file
C $ Input:
C $ ICLIM = (I)  If =0, get 40 levels profile from VASGSS;
C $              If =1 climatology ; If =2 get from MD profile
C $ NOSFC = (I)  IF =0 add surface data fron analyses
C $ MDNO  = (I) MD file for guess profiles (VASTEXT word NO. 38)
C $$ GESPRO = VAS
C
C     SURFACE DATA REQUIRES SPECIFICATION OF GRID FILE AND GRID NOS.
C     THESE ARE OBTAINED FROM VASTEXT, ROUTINE ASSUMES THAT COMMON/DOC/
C     HAS BEEN READ IN MAIN PROGRAM
C
C     LOCATION AND SURFACE ELEVATION MUST BE PASSED IN COMMON/NAV/
C     FOR LAT/LON AND /SURF/ FOR IEL
C
      COMMON/ATMOS/P(40),T(40),W(40)
      COMMON/DBUG/KBUG
      COMMON/DOC/IDOC(100)
      COMMON/GUESR/TGESR(24),DGESR(19)
C     /GUESR/ IS SPECIFIC TO REGIONAL MODEL; USUAL GUESS PROFILE IS
C     RETURNED AT 15 AND 6 LEVELS (VIZ. CLMGES,RAOBIN)
      COMMON/GUESS/TGES(15),DGES(6)
      COMMON/HISTOR/MD1,MD2
      COMMON/NAV/VLAT,VLON,VZEN,SZEN,IL,IE,IRAS,IPIC,ITIME,JTIME,JDAY
      COMMON/ORGES/TG(40),WG(40),KDUM(3)
      COMMON/RAOB/MYDHH,NRAOB
C     /GDATE/RETURNS YYDDD,HHMM,AND LAT OF GUESS
      COMMON/GDATE/MDATE(3)
      COMMON/SURF/IZ10,ITSFC,IDSFC,IPSTA,IEL,LSTA
      CHARACTER*12 CFI,CFF
      DIMENSION PS(24),PR(24),TR(24),DR(24),WR(24),LR(15)
      DIMENSION WP(40)
      DIMENSION LBUF(33),NS(24)
      DATA LBUF/33*Z'40404040'/,INIT/0/,DEWTOP/0./
C     LR IS SUBSCRIPT ARRAY FOR MANDATORY P LEVELS IN /ATMOS/ARRAY
      DATA LR/40,37,35,31,28,26,25,24,23,20,18,16,15,13,11/
      DATA PR/10.,20.,30.,50.,70.,100.,150.,200.,250.,300.,350.,400.,
     * 450,500,550,600,650,700.,750.,800.,850.,900.,950.,1000./
      DATA DELP10/.5145732/,VMISG/999./,NL/40/,INIV/1/
      FS2(I)=.01*FLOAT(I)
C * INITIALIZE STANDARD ATMOSPHERE...ESPECIALLY PRESSURE ARRAY
      CALL STDATM(P,T,W)
      IF(ICLIM.NE.2) GO TO 100
C * READ DOCUMENTATION TO GET RAOB INFO
      MD1=IDOC(43)
      MD2=IDOC(44)
      MYDHH=IDOC(45)*100+IDOC(46)
      MDATE(1)=IDOC(45)
      MDATE(2)=IDOC(46)*100
      NRAOB=IDOC(47)
      CALL RAOBIN(P,T,W,IOK)
      IF(IOK.EQ.0) GO TO 120
      TGES(1)=-999.
      RETURN
  100 CONTINUE
      CALL CLMGES
      IF(ICLIM.EQ.1) THEN
         MDATE(1)=0
         MDATE(2)=0
         GO TO 120
      ENDIF
      CALL VASGES(MDNO,VLAT,VLON)
C * RETURN PROFILES OF TGES,DGES (DEWPOINT) AND /SURF/ DATA
C    THESE ARE ORDERED 1000 MB TO (AS HIGH AS) 10 MB
C    DATA UP TO 100 MB MUST BE AVAILABLE OR FAILURE FLAG IS INDICATED
      IF(INIV.NE.0) THEN
C * STORE GUESS DATE & TIME FOR LATER USE
         IDOC(33)=MDATE(1)
         IDOC(34)=MDATE(2)
         INIV=0
      ENDIF
      IF(TGES(1).LT.0.) RETURN
  120 CALL SURGES(NOSFC)
      IF(IPSTA.NE.999999) GO TO 140
      TGES(1)=-999.
      RETURN
  140 CONTINUE
      TSFC=FS2(ITSFC)
      DSFC=FS2(IDSFC)
      DEW=TSFC-DSFC
      PST=FLOAT(IPSTA)
      LSTA=LEVSFC(PST)
      TSAV=0.
      IF(ICLIM.EQ.1) GO TO 230
      IF(ICLIM.EQ.2) GO TO 230
C * NR IS NO. OF INPUT LEVELS FOR TEMP
      NR=24
C * SET IM = SUBSCRIPT IN 40 LEVEL PROFILE FOR LOWEST PRESSURE INPUT
C    LESS 1; 10 = 7MB, 15 = 30MB
      IM=10
C     CHECK FOR TOP LEVEL
C * 10 MB
      IF (TGESR(24).NE.999.)GO TO 160
      IM=12
C * 20 MB
      IF (TGESR(23).NE.999.)GO TO 160
      IM=14
C * 30 MB
      IF (TGESR(22).NE.999.)GO TO 160
      IM=15
C * 50 MB
      IF(TGESR(21).NE.999.) GO TO 160
C * IF 50 MB DATA IS NOT AVAILABLE SET IT TO FIXED TEMP AND
C    INTERPOLATE 70 MB.
      TGESR(21)=213.
      TGESR(20)=TGESR(19)+(TGESR(21)-TGESR(19))*DELP10
  160 CONTINUE
C
C * "IS" = SUBSCRIPT OF LEVEL ABOVE WHICH TO INVENT PROFILE IN PROFIX
C
      IS=IM+1
C
C * "NI" = NO. OUTPUT LEVELS INTO WHICH TO INTERPOLATE IN PROFIX
C
      NI=NL-IM
C
C * SET UP INDEXING TO INVERT DATA IN PRESSURE COORDINATE; INPUT IS SURF
C     FIRST, WE WILL INTERPOLATE AS SURFACE LAST, LIKE 40 LEVEL PROFILE.
C     ARRAYS ARE PS,TR AND DR.
C     SET INDEX TO NO OF INPUT LEVELS+1
C
      NQ=25
      L=0
      ICT=0
      DO 240 J=1,NR
C
C     J IS TOP DOWN SUBSCRIPT, I IS BOTTOM UP SUBSCRIPT
C
      I=NQ-J
      IF (TGESR(I) .EQ. 999.) GO TO 240
      L=L+1
C     SAVE SUBSCRIPT ARRAY TO RESTORE /GESR/ BELOW ALSO AS INCREASING PR
      NS(L)=J
      PS(L)=PR(J)
      TR(L)=TGESR(I)
      DR(L)=36.9
C
C     ACCOUNT FOR DEWPOINT ARRAY ONLY IDENTIFIED TO 19 LEVELS..
C
      IF (I.GT.19) GO TO 240
      IF (DGESR(I).EQ.999.) THEN
C
C     IF DEWPOINT IS MISSING BELOW 300 hPa, REPEAT PREVIOUS LEVEL DEPRES
C     UNLESS IT IS MISSING FOR TWO CONSECUTIVE TEMP LEVELS IN WHICH CASE
C     FLAG AS BAD GUESS AND, EXIT.  ABOVE 300 LEAVE DEPRESSION AT 36.9.
C
         IF (I.LE.15) THEN
            ICT=ICT+1
            IF (ICT.GT.1) THEN
               DGES(1)=-999.
               RETURN
            ELSE
               DR(L)=DR(L-1)
            ENDIF
         ENDIF
      ELSE
         ICT=0
         DR(L)=TR(L)-DGESR(I)
         IF (DEWTOP .EQ. 0.) DEWTOP = PS(L)
      ENDIF
  240 CONTINUE
C
C     AT THIS POINT "L" IS THE NO. OF LEVELS, LOW TO HIGH PRESSURE
C
C * AVOID SURFACE INFLECTIONS IN LOW LEVEL INTERPOLATIONS, IT IS ASSUMED
C   THAT THE SURFACE WILL BE HANDLED IN MAIN PROGRAM (E.G. PBLEND) FOR
C   /ATMOS/; WE WILL RESTORE BELOW IN /GES/
C
C    LOCATE FIRST LEVEL ABOVE SURFACE (IN PS ARRAY), UP TO 700 hPa
C
      DO N=1,6
        K=L-N
        IF (PS(K).LT.PST) GO TO 200
      ENDDO
  200 M=K+1
C
C     M IS SUBSCRIPT FOR LEVEL AT OR BELOW SURFACE
C
      MSAV=M
      TSAV=TR(M)
      DSAV=DR(M)
C * EXTRAPOLATE GUESS T AND D TO 1ST LEVEL BELOW SURFACE
C   RETAIN DEWPOINT DEPRESSION (DR
      DLP=ALOG(PS(M)/PS(K-1))/ALOG(PS(K)/PS(K-1))
      DELT=TR(K)-TR(K-1)
      TR(M)=TR(K-1)+DELT*DLP
  220 CONTINUE
  225 CALL PROFIX(PS(1),TR(1),DR(1),WR(1),P,T,W,NI,IM,IS,L,VLAT)
C   REDO MIXING RATIO PROFILE FROM 300 TO 70 MB
C   SUBSCRIPTS (IN 40 LEVEL) ARE 26 AND 18 RESPECTIVELY
      IF (INIT .EQ. 0) THEN
C     ASSUME THAT ALL GUESS PROFILES EXTEND TO SAME LEVEL, FIND OUT WHER
C     THE DEWPOINT GUESS REALLY QUIT, THEN SET UP EXPONENTIAL DECAY TO I
         DO I=IM,NL
            IF (DEWTOP .EQ. P(I)) THEN
               IB = I
               GO TO 227
            ENDIF
         ENDDO
  227    PB=P(IB)
         DO I=IB-1,IM,-1
            WP(I)=(P(I)/PB)**3
         ENDDO
         INIT=1
      ENDIF
      WB=W(IB)
      DO I=IB-1,IM,-1
         WJ=WB*WP(I)
         W(I)=AMAX1(WJ,0.003)
      ENDDO
C
C     PULL OUT STANDARD LEVELS
C
  230 DO 250 I=1,15
      L=LR(I)
  250 TGES(I)=T(L)
      DO 260 I=1,6
      L=LR(I)
      DGES(I)=DEWPT(P(L),T(L),W(L))
  260 CONTINUE
C
C    INSERT TSAV,DSAV AT LEVEL BELOW SURFACE IN 40 LEVEL ARRAY
C    LOCATE FIRST LEVEL ABOVE SURFACE (IN P ARRAY), UP TO 700 hPa
C
      DO N=1,6
        K=NL-N
        IF (P(K).LT.PST) GO TO 270
      ENDDO
  270 M=K+1
      T(M)=TSAV
      CALL WMIX(P(M),T(M),W(M),DSAV,1)
      IF (M .LT. NL) THEN
         DO I=M+1,NL
            T(I)=T(M)
            W(I)=W(M)
         ENDDO
      ENDIF
C
C * RESTORE ORIGINAL GUESS IF M IS 700,850, OR 1000 MB (18,21,24)
      K=0
      M=NS(MSAV)
      IF (M.EQ.18)K=3
      IF (M.EQ.21)K=2
      IF (M.EQ.24)K=1
      IF (K.EQ.0)GO TO 300
      TGES(K)=TSAV
      DGES(K)=TSAV-DSAV
  300 CONTINUE
      DO 320 I=1,NL
      WG(I)=W(I)
  320 TG(I)=T(I)
      RETURN
      END
