      SUBROUTINE GETSFV
C $ SUBROUTINE GETSFV          (CMH)
C $ GET VALUES FROM SURFACE GRIDS
C $ THIS ROUTINE REQUIRES A "TEXT" FILE TO LOCATE GRIDS OF 1000MB Z,
C $     SEA LEVEL TEMPERATURE, AND SURFACE DEWPOINT DEPRESSION.
C $$ GETSFV = VAS,OBSERVATION,I/O
      DIMENSION IDL(12000,3),NGRNO(3),FSFC(3),SCL(3),IGFLNM(2),KOUT(10)
     &, LBUF(33)
      COMMON /NAV/VLAT,VLON,VZEN,SZEN,IL,IE,IRAS,IPIC,ITIME,JTIME,JDAY
      COMMON /SURF/ISFC(6)
      COMMON /DOC/IDOC(112)
      COMMON /SDOC/ISDOC(6)
      COMMON /DBUG/KBUG
C-----DESCRIPTION OF 64-WORD GRID HEADERS
C
      INTEGER IGHD(64),IGHDS(64)
      INTEGER IGID(8)
C-----GIVE TOTAL SIZE (WORDS), # ROWS, # COLS. (IGSIZE=IGNR*IGNC)
      EQUIVALENCE (IGSIZE,IGHD(1)),(IGNR,IGHD(2)),(IGNC,IGHD(3))
C-----YYDDD, HHMMSS AND VALID-TIME (IF APPLICABLE) FOR GRID
      EQUIVALENCE (IGDAY,IGHD(4)),(IGTIME,IGHD(5)),(IGTIMV,IGHD(6))
C-----DESCRIPTION OF GRIDDED VARIABLE (IN MD-FILE TERMS):
C-----   NAME, SCALE, AND UNITS
      EQUIVALENCE (IGVNAM,IGHD(7)),(IGVSCA,IGHD(8)),(IGVUNI,IGHD(9))
C-----DESCRIPTION OF VERTICAL LEVEL: VALUE, SCALE, AND UNITS
      EQUIVALENCE (IGLEVL,IGHD(10)),(IGLSCA,IGHD(11)),(IGLUNI,IGHD(12))
C-----GRIDDED-VARIABLE TYPE: =1 (TIME DIF) 2(TIME AVG) 4 (LEVEL DIF)
C-----   8 (LEVEL AVG) OR ANY SUM OF THE FOREGOING
      EQUIVALENCE (IGVTYP,IGHD(13))
C-----FOLLOWING USED IF PARAMETER IS A VERTICAL (LEVEL) DIF OR AVG
C-----   (SAME SCALE AS IGLEVL)
      EQUIVALENCE (IGLDIF,IGHD(14))
C-----FOLLOWING USED IF PARAMETER IS A TIME DIF OR AVG (HHMMSS)
      EQUIVALENCE (IGTDIF,IGHD(15))
C-----GRID ORIGIN, TYPE (I.E. TYPE OF PROJECTION)
      EQUIVALENCE (IGORG,IGHD(33)),(IGTYPE,IGHD(34))
C-----SUBSEQUENT COORDS (IGLAMX,IGLOMX,IGLAMN,IGLOMN,IGINCR,
C-----   IGPOLR,IGPOLC,IGSP60,IGCLON) ALL HAVE 4 IMPLIED DEC. PLACES.
C-----   LAT GOES FROM -900000 TO 900000, LON GOES FROM -1800000
C-----   TO 1800000 (WEST IS +)
C-----TYPE 1 GRIDS ARE PSEUDO-MERCATOR
      EQUIVALENCE (IGLAMX,IGHD(35)),(IGLOMX,IGHD(36)),(IGLAMN,IGHD(37))
     *   ,(IGLOMN,IGHD(38)),(IGINCR,IGHD(39))
C-----TYPE 2 GRIDS ARE POLAR-STEREOGRAPHIC
C-----GIVE ROW # OF NORTH POLE, COL # OF N.P., COL SPACING AT 60 DEG N.
C-----   (DEG), LONGITUDE PARALLEL TO COLUMNS (DEG)
      EQUIVALENCE (IGPOLR,IGHD(35)),(IGPOLC,IGHD(36)),(IGSP60,IGHD(37))
     *   ,(IGCLON,IGHD(38))
C-----INITIALS OF USER AND PROJECT # UNDER WHICH GRID CREATED
      EQUIVALENCE (IGUSER,IGHD(41)),(IGPROJ,IGHD(42))
C-----CHARACTER ID SUPPLIED BY PROGRAM (ARBITRARY)
      EQUIVALENCE (IGID,IGHD(43))
      EQUIVALENCE (NGRNO(1),IDOC(30))
      DATA INIT/1/
C
      IF(INIT.EQ.0) GO TO 110
      NGRFS=IDOC(29)
      DO 100 N=1,3
      IOK=IGGET(NGRFS,NGRNO(N),12000,IDL(1,N),NROWS,NCOLS,IGHD)
      IF (IOK.LT.0)GO TO 300
      SCL(N)=10.**IGVSCA
C     INSURE THAT GRIDS HAVE SAME DIMENSIONS
      IF (N.GT.1)THEN
      DO 50 ICK=34,39
        IF (IGHD(ICK).NE.IGHDS(ICK))THEN
         CALL SDEST(' SURFACE GRIDS ARE NOT OF SAME DIMENSIONS ',0)
         CALL MCABORT(5)
        ENDIF
   50 CONTINUE
      ENDIF
      DO 75 ICK=34,39
   75 IGHDS(ICK)=IGHD(ICK)
C
  100 CONTINUE
      CALL GRDDEF(IGHD)
      CALL IGNAME(NGRFS,IGFLNM)
CCX   CALL LWCLOS(IGFLNM)
      ISDOC(1)=IGLAMX
      ISDOC(2)=IGLOMX
      ISDOC(3)=IGLAMN
      ISDOC(4)=IGLOMN
      ISDOC(5)=IGINCR
      IDAY=MOD(IGDAY,1000)
      IHR=IGTIME/10000
      ISDOC(6)=IDAY*100+IHR
      IF(KBUG.EQ.0) GO TO 130
      KOUT(1)=6
      DO 120 I=1,6
      KOUT(I+1)=ISDOC(I)
  120 CONTINUE
C     CALL OUTINT(KOUT)
  130 CONTINUE
      CONV=0.
C     SET UP FOR DATELINE AMBIGUITY
      IF (IGLOMX.LT.IGLOMN)CONV=1.
      INIT=0
  110 CONTINUE
      ISFC(4)=0
      FLON=VLON
      IF (CONV.EQ.1.AND.FLON.GT.0)FLON=FLON-360.
      CALL LLIJ(VLAT,FLON,VLATJ,VLONI)
C     ROW & COL NUMBERING SYSTEM STARTS AT 0
      VLATJ=VLATJ-1.0
      VLONI=VLONI-1.0
      ICOL=VLONI
      IF (ICOL.GE.NCOLS)GO TO 200
      IF (ICOL.LT.0)GO TO 200
      DELI=VLONI-ICOL
      IROW=VLATJ
      IF (IROW.GE.NROWS)GO TO 200
      IF (IROW.LT.0)GO TO 200
      DELJ=VLATJ-IROW
      L=ICOL*NROWS+IROW+1
      IF (ICOL.EQ.NCOLS-1)DELI=0.
      IF (IROW.EQ.NROWS-1)DELJ=0.
      DO 150 N=1,3
      FSFC(N)=TERP(IDL(L,N),IDL(L+NROWS,N),IDL(L+1,N),IDL(L+NROWS+1,N),
     *DELI,DELJ)/SCL(N)
  150 CONTINUE
C     RETURN TEMP AND TD AS DEG*100
      ISFC(2)=FSFC(2)*100.
      ISFC(3)=FSFC(3)*100.
      ISFC(1)=FSFC(1)
      RETURN
  200 CONTINUE
      ISFC(4)=999999
      RETURN
  300 CALL SDEST(' GETSFV...CANNOT READ SURFACE GRID NO. ',NGRNO(N))
      CALL MCABORT(0)
      RETURN
      END
C HAD TO COMMENT OUT FUNCTION TERP BECAUSE VASGES CALLS GETSFV
C WHICH HAS FUNCTION TERP DEFINED IN IT ALREADY
C      FUNCTION TERP(O1,O2,O3,O4,DELI,DELJ)
C $ FUNCTION TERP(01,02,03,04,DELI,DELJ)              (CMH)
C $ INTERPOLATE A VALUE IN TWO DIMENSIONS; FUNCTION VALUE IS THE
C $     INTERPOLATED VALUE
C $ INPUT:  O1 = (I) TOP LEFT VALUE
C $         O2 = (I) TOP RIGHT VALUE
C $         O3 = (I) BOTTOM LEFT VALUE
C $         O4 = (I) BOTTOM RIGHT VALUE
C $         DELI = (R) HORIZONTAL INCREMENT
C $         DELJ = (R) VERTICAL INCREMENT
C $$ TERP = VAS,MV,COMPUTATION
C      INTEGER*4 O1,O2,O3,O4
C      TL=FLOAT(O1)
C      TR=FLOAT(O2)
C      BL=FLOAT(O3)
C      BR=FLOAT(O4)
C      TOP=TL+DELI*(TR-TL)
C      BOT=BL+DELI*(BR-BL)
C      TERP=TOP+DELJ*(BOT-TOP)
C      RETURN
C      END
