C ***************************************************************
C  GETSTNS.FOR		PROGRAMMED BY : Gerald Hartling 3/21/1997
C
C  Reads the station list from a text file. It is assumed that
C  there is only one station per line, that it begins at 'ipos',
C   that it is <= 4 characters in length and that the state 
C  abreviation follows it and is separated by 'ctag'.
C ***************************************************************

      SUBROUTINE GETSTNS(CSTNS, NUM)
      include "imasos.h"
      character*2 ctag
      character*5 cstns(MAXSTNS)
      character*100 cbuf
      integer num
      integer maxnum
      include "getstns.h"
      data ctag / ',' /

      open (unit=1, file=cstalst, status='old') 
      open (unit=2, file='stns.dat') 

C ***************************************************************
C  If the number of stations to be read is <= 0 then loop through
C  the max number of stations until the end of file.
C ***************************************************************
      if (num.le.0) then
        maxnum = MAXSTNS
      else
        maxnum = num
      end if

C ***************************************************************
C  Get the station ID and then search for the state abbr.
C ***************************************************************
      write(2,100)
      do 20 i=1,maxnum
        read(1, '(A80)', end=50) cbuf
        cstns(i)(1:4) = cbuf(ipos:ipos+3)

C ***************************************************************
C  Find the state abbr.
C ***************************************************************
        do 10 j=ipos+4, charlen-1
             if ( cbuf(j:j).eq.ctag(1:1) ) exit do 10 j=ipos+4
  10    continue

        if (cbuf(j+1:j+1).eq.' ') j=j+1
C ***************************************************************
C  Identify which state abbr. it is and then assign it a region
C  number. If the the station can't be matched up with a region
C  number then fill the spot with a blank.
C ***************************************************************
        do 5 k=1,NUMST
             if ( states(k)(1:2).eq.cbuf(j+1:j+2) ) then
                  cstns(i)(5:5) = states(k)(4:4)
                  exit do 5 k=1
             else
                  cstns(i)(5:5) = ' '
             end if
   5    continue     
        if (k.gt.NUMST) then
             write(2,200) cstns(i), 'No matching states', i, j, 999, 
     $            cbuf(j:j+1)
        else
             write(2,200) cstns(i), states(k), i, j, k, cbuf(j:j+1)
        end if
  20  continue
  50  num = i-1
  60  close(1)
      close(2)
C
 100  format(' STN  ',13x,'STATE')
 200  format(a5,5x,a30,2x,i4,2x,i4,2x,i4,2x,a2)
      return
      end
