      SUBROUTINE INTPTW(PI,TI,WI,PF,TF,WF,NI,NF)
C $ SUBROUTINE INTPTW(PI,TI,WI,PF,TF,WF,NI,NF)             (BTR)
C $ INTPTW - linearly interpolate in LN P profiles of T and W
C $ Input:
C $    PI = (R) Input pressure profile to be interpolated to given PF,
C $             Min to Max -- I.E., top-down
C $    TI = (R) temperature profile
C $    WI = (R) Mixing ratio profile
C $    PF = (R) Pressure profile, Min to Max -- I.E., top-down
C $ Output:
C $    TF = (R) Temperature profile
C $    WF = (R) Mixing ratio profile
C $    NI = (I) Nnmber of input levels
C $    NF = (I) Number of output levels
C $$ INTPTW = VAS, COMPUTATION
C     XQW 93/08/24  SET SLOPT=0 & SLOPW=0 SO THAT OLD SLOPES WON'T
C                   CAUSE TROUBLE.
      DIMENSION PI(1),TI(1),WI(1),PF(1),TF(1),WF(1)
      SLOPT = 0.
      SLOPW = 0.
      IJ=1
      II=1
      DO 160 I=1,NF
      DO 140 J=IJ,NI
      JM1=J-1
      IF (JM1.LT.1)JM1=1
      IF(ABS(PI(J)-PF(I)).LE..001) GO TO 110
      IF(PI(J)-PF(I)) 140,110,120
  110 TF(I)=TI(J)
      WF(I)=WI(J)
      GO TO 150
  120 IF(J.EQ.IJ) GO TO 130
      DLPI=ALOG(PI(J)/PI(JM1))
      SLOPT=(TI(J)-TI(JM1))/DLPI
      SLOPW=(WI(J)-WI(JM1))/DLPI
      II=J
  130 CONTINUE
      DLPF=ALOG(PF(I)/PI(JM1))
      TF(I)=TI(JM1)+SLOPT*DLPF
      WF(I)=WI(JM1)+SLOPW*DLPF
      GO TO 150
  140 CONTINUE
  150 IJ=II
  160 CONTINUE
      RETURN
      END
