      FUNCTION LWOPN(DFILE, LDN, LREC)                                          
C                                                                               
C $ FUNCTION LWOPN(DFILE, LDN, LREC)                                            
C $ OPEN LW FILE                                                                
C $ DFILE = (R*8) LW FILE NAME                                                  
C $ LDN   = (I*4) LOGICAL UNIT NUMBER                                           
C $ LREC  = (I*4) RECORD LENGTH (WORDS)                                         
C $ LWOPN FUNCTION VALUE =  1 - FILE SUCCESSFULLY OPENED                        
C $                        -1 - FILE ALREADY OPENED                             
C $                        -2 - FILE ASSIGNED TO OTHER UNIT                     
C $                        -3 - NO ROOM TO OPEN FILE                            
C $                        -4 - FILE HAS NO DATA (I.E., MISSING)
C                                                                               
      CHARACTER*80 CTEXT  
      CHARACTER*8 CFNAME                                                      
      REAL*8 DNAMES, DNAME, DFILE, DNULL, DLIST(96)  
      DIMENSION LIST(192), IBUF(2)
C                                                                               
      COMMON /DAIO/ DNAMES(16),LRECL(16),LUNS(16),JROFF(16),JWOFF(16),          
     1  KPROT(16)                                                               
C                                                                               
      EQUIVALENCE (DLIST(1),LIST(1))
      EQUIVALENCE (DNAME, CFNAME)
      DATA INIT /0/                                                             
      DATA DNULL /Z'80808080'/
C                                                                               
      LWOPN = 1                                                                 
      LUN = IABS(LDN)                                                           
      IF (INIT .NE. 0) GO TO 150                                                
C                                                                               
C     FIRST ENTRY                                                               
C                                                                               
      INIT = 1                                                                  
      DO 100 J = 1, 16                                                          
        LUNS(J) = -1                                                            
        JROFF(J) = 0                                                            
        JWOFF(J) = 0                                                            
        KPROT(J) = 0                                                            
        DNAMES(J) = 0.D+0                                                       
  100 CONTINUE                                                                  
C                                                                               
  150 CONTINUE                                                                  
C                                                                               
      DO 200 J = 1, 16                                                          
        IF (LUNS(J) .EQ. LUN) THEN                                              
C                                                                               
C         LWOPN ERROR - UNIT ALREADY ASSIGNED TO ANOTHER FILE                   
C                                                                               
          WRITE(CTEXT,1000) LUN, DNAMES(J)                                      
          CALL SDEST(CTEXT,0)                                                   
          LWOPN = -2                                                            
          GO TO 900                                                             
        ENDIF                                                                   
  200 CONTINUE                                                                  
C                                                                               
      DO 300 J = 1, 16                                                          
        JJ = J                                                                  
        IF (DNAMES(J) .EQ. DFILE) THEN                                          
C                                                                               
C         LWOPN ERROR - FILE ALREADY OPEN                                       
C                                                                               
          WRITE(CTEXT,2000) DFILE                                               
          CALL SDEST(CTEXT,0)                                                   
          LWOPN = -1                                                            
          GO TO 900                                                             
        ENDIF                                                                   
        IF (LUNS(J) .EQ. -1) GO TO 350                                          
  300 CONTINUE                                                                  
C                                                                               
C     LWOPN ERROR - NO MORE FILES ALLOWED                                       
C                                                                               
      WRITE(CTEXT,3000) DFILE                                                   
      CALL SDEST(CTEXT,0)                                                       
      LWOPN = -3                                                                
      GO TO 900                                                                 
  350 CONTINUE                                                                  
C  
C     FOUND A VACANT SLOT                                                       
C     FIRST CHECK FOR DATA
C 
      IWORD = 0 
      IREC = 1 
      DNAME = DFILE 
      JSTAT = LWI(CFNAME, IWORD, IREC, IBUF)
      IF (JSTAT.NE.0) THEN
C                                                                               
C       LWOPN ERROR - NO DATA 
C                                                                               
        WRITE(CTEXT,4000) DFILE   
        CALL SDEST(CTEXT,0)   
        LWOPN = -4  
        GO TO 900    
      ENDIF 
C  
C     FILL VACANT SLOT                                                       
C                                                                               
      LRECL(JJ) = LREC                                                          
      LUNS(JJ) = LUN                                                            
      DNAMES(JJ) = DFILE                                                        
C                                                                               
C     LDN < 0  SIGNIFIES A READ-ONLY FILE                                       
C                                                                               
      IF (LDN .LT. 0) KPROT(JJ) = 1                                             
C                                                                               
C     NOW UPDATE DAUSAGE FILE                                                   
C                                                                               
      DO 450 N = 1, 100000                                                      
        JWORD = 192*(N - 1)                                                     
        JS = LWI('DAUSAGE ', JWORD, 192, DLIST)                                 
C                                                                               
        DO 400 J = 1, 64                                                        
          JJ = J                                                                
          IF (DLIST(J) .EQ. DFILE .OR. DLIST(J) .EQ. DNULL) GO TO 500           
  400   CONTINUE                                                                
C                                                                               
  450 CONTINUE                                                                  
  500 CONTINUE                                                                  
C                                                                               
      CALL MCGETDAY(LIST(JJ+128))                                                 
      DLIST(JJ) = DFILE                                                         
      JS = LWO('DAUSAGE ', JWORD, 192, DLIST)                                   
      CALL LWMOP('DAUSAGE ')                                                    
C                                                                               
  900 CONTINUE                                                                  
      RETURN                                                                    
 1000 FORMAT(' LWOPN ERROR - UNIT ',I4,' ALREADY ASSIGNED TO FILE ',A8)         
 2000 FORMAT(' LWOPN ERROR FOR FILE ',A8,' - FILE ALREADY OPEN')                
 3000 FORMAT(' LWOPN ERROR FOR FILE ',A8,' - NO MORE FILES ALLOWED')            
 4000 FORMAT(' LWOPN ERROR FOR FILE ',A8,' - NO DATA FOUND') 
      END                                                                       
