      FUNCTION LWRITE( LUN, NRECRD, JBUF)                                       
C                                                                               
C $ FUNCTION LWRITE(LUN, NRECRD, JBUF)                                          
C $ WRITE TO LW FILE                                                            
C $ LUN    = (I*4)  LOGICAL UNIT NUMBER                                         
C $ NRECRD = (I*4)  RECORD NUMBER                                               
C $ JBUF   = (I*4)  BUFFER CONTAINING RECORD                                    
C $ LWRITE FUNCTION VALUE = 1 - RECORD SUCCESSFULLY WRITTEN                     
C $                         0 - FILE IS READ-ONLY                               
C $                        -1 - UNIT NOT ASSIGNED                               
C $                        -2 - RECORD ZERO OR NEGATIVE                         
C $                        -3 - LWO WRITE ERROR                                 
C $                                                                             
      REAL*8 DNAMES, DFILE                                                      
      CHARACTER*8 CFNAME                                                        
      CHARACTER*80 CTEXT                                                        
      DIMENSION JBUF(2)                                                         
C                                                                               
      COMMON/DAIO/ DNAMES(16),LRECL(16),LUNS(16),JROFF(16),JWOFF(16),           
     1  KPROT(16)                                                               
      EQUIVALENCE (CFNAME,DFILE)                                                
C                                                                               
      LWRITE = 1                                                                
C                                                                               
      DO 100 J = 1, 16                                                          
        JJ = J                                                                  
        IF (LUNS(J) .EQ. LUN) GO TO 200                                         
  100 CONTINUE                                                                  
C                                                                               
C     LWRITE ERROR - LOGICAL UNIT NUMBER NOT ASSIGNED                           
C                                                                               
      WRITE(CTEXT,1000) LUN                                                     
      CALL SDEST(CTEXT,0)                                                       
      LWRITE = -1                                                               
      GO TO 900                                                                 
C                                                                               
  200 CONTINUE                                                                  
      DFILE = DNAMES(JJ)                                                        
      IF (KPROT(JJ) .NE. 0) THEN                                                
C                                                                               
C       LWRITE ERROR - FILE IS READ-ONLY                                        
C                                                                               
        WRITE(CTEXT,2000) DFILE                                                 
        CALL SDEST(CTEXT,0)                                                     
        LWRITE = 0                                                              
        GO TO 900                                                               
      ENDIF                                                                     
C                                                                               
      NREC = NRECRD + JROFF(JJ)                                                 
      IF (NREC .LE. 0) THEN                                                     
C                                                                               
C       LWRITE ERROR - RECORD NUMBER ZERO OR NEGATIVE                           
C                                                                               
        WRITE(CTEXT,3000) DFILE, NREC                                           
        CALL SDEST(CTEXT,0)                                                     
        LWRITE = -2                                                             
        GO TO 900                                                               
      ENDIF                                                                     
C                                                                               
      JWORD = (NREC-1)*LRECL(JJ) + JWOFF(JJ)                                    
      JSTAT = LWO(CFNAME, JWORD, LRECL(JJ), JBUF)                               
      IF (JSTAT .NE. 0) THEN                                                    
C                                                                               
C       LWRITE ERROR - OTHER WRITE ERROR                                        
C                                                                               
        WRITE(CTEXT,4000) DFILE, NREC                                           
        CALL SDEST(CTEXT,0)                                                     
        LWRITE = -3                                                             
      ENDIF                                                                     
C                                                                               
  900 CONTINUE                                                                  
      RETURN                                                                    
 1000 FORMAT(' LWRITE ERROR - UNIT ',I4,' IS NOT ASSIGNED')                     
 2000 FORMAT(' LWRITE ERROR - FILE ',A8,' IS READ-ONLY')                        
 3000 FORMAT(' LWRITE ERROR FOR FILE ',A8,' - RECORD ',I4,                      
     1  ' CANNOT BE ZERO OR NEGATIVE')                                          
 4000 FORMAT(' LWRITE ERROR FOR FILE ',A8,' - RECORD ',I4,                      
     1  ' HAS LWO WRITE ERROR')                                                 
      END                                                                       
