C Copyright(c) 2003, Space Science and Engineering Center, UW-Madison
C Refer to "McIDAS Software Acquisition and Distribution Policies"
C in the file  mcidas/data/license.txt

C *** $Id: mdfilename.f,v 1.3 2003/09/18 16:09:23 daves Exp $ ***

*$ Name:
*$      mdfilename - create a filename from a MD file number for use
*$                   with server file masks
*$
*$ Interface:
*$      integer function
*$      mdfilename(integer mdno, character*(*) filenam)
*$
*$ Input:
*$      mdno    - MD file number
*$
*$ Input and Output:
*$      none
*$
*$ Output:
*$      filenam - filename
*$
*$ Return values:
*$      Check that the MD file number is in the valid range before
*$      calling this routine.
*$
*$ Remarks:
*$      none
*$
*$ Categories:
*$      converter
*$      point

      integer function mdfilename(mdno,cfile)
      IMPLICIT NONE
      include 'ptparm.inc'
      integer mdno, nfiles, num
      character*(*) cfile
      character*(*) gathered_files(*)
      CHARACTER*512 local_list(MAXMDFILES)

C --- external functions

      CHARACTER*12 CFJ
      integer len_trim

C --- local variables

      integer i
      character*12 ctemp
      integer length, mdfullpathname
        
      data nfiles /-1/
c
c ---- If the server passed in a list of MDfilenames, use them.
c 
      if(nfiles .gt. 0 ) then
c
c ---- If requested mdno is too large, error exit
c
         if(mdno .gt. nfiles) then
            cfile = ' '
            mdfilename = -1
            return
         endif

         cfile = local_list(mdno)
         mdfilename=0
         return
      endif

c
c ---- This is the original way to determine filename
c
      ctemp=cfj(mdno)

      if (mdno .lt. 10000) then
         ctemp(5:8)='MDXX'
      elseif (mdno .LT. 100000) then
         ctemp(5:7)='MDX'
      else
         ctemp(5:6)='MD'
      endif
      
      cfile = ctemp(5:12)

      mdfilename = 0
      return

c
c Entry point for MD servers to use DIRFILE [file masking]
c
      entry mdfullpathname(num, gathered_files)

      nfiles = num
      if(nfiles .le. 0)  then
         mdfullpathname=-1
         return
      endif

      do i = 1, nfiles
         length=len_trim(gathered_files(i))
         if(length.le.0)  then
            mdfullpathname=-1
            return
         endif

         local_list(i) = gathered_files(i)
      enddo

      mdfullpathname=0

      RETURN
      END	
