C Copyright(c) 1997, Space Science and Engineering Center, UW-Madison
C Refer to "McIDAS Software Acquisition and Distribution Policies"
C in the file  mcidas/data/license.txt

C *** $Id: mdget.for,v 1.1 2007/02/12 19:53:48 rrollins Exp $ ***

C MDGET  BARRET 1181  GET RECORD FROM MD FILE
C $ FUNCTION MDGET(MDNO, M, N, ARRAY)  (GAD)
C $ GET RECORD FROM MD FILE. RETURNS 0 (OK), OR -1 (CAN'T, I.E., NO SUCH
C $   RECORD).
C $ INPUT:
C $   MDNO = (I) THE MD FILE #
C $   M, N = (I) ROW, COLUMN #'S OF DESIRED RECORD. IF M=0, A COLUMN
C $      HEADER IS DESIGNATED. IF N=0, A ROW HEADER IS DESIGNATED.
C $   ARRAY = (I) MUST BE LONG ENOUGH TO CONTAIN ALL THE DESIRED RECORD,
C $      NOT JUST THE PORTION BEING READ. THIS IS BECAUSE ROW HEADERS,
C $      COLUMN HEADERS & DATA RECORDS ARE EACH READ INTO DIFFERENT
C $      REGIONS WITHIN ARRAY, SO THEY WILL MATCH UP PROPERLY WITH THEIR
C $      RESPECTIVE KEYS.
C $$ MDGET = MD, I/O

      FUNCTION MDGET(MDNO,M,N,ARRAY)
      IMPLICIT INTEGER (A-Z)
      DIMENSION ARRAY(*)
C-----FOLLOWING COMMON BLOCK GIVES LAYOUT OF FILE HEADER.
      COMMON/MDCOM/ SNAME,SVSN,SDATE,NR,NC,NKEYS,NRKEYS,NCKEYS,NDKEYS,
     &   CPOS,DPOS,NREPS,REPSIZ,REPPOS,MDATA,ID,TEXTID(8),CPROJ,CDATE,
     &   COWNER,FRHOF,FCHOF,FDATOF,FENDOF,FUSROF,FNAMOF,FSCAOF,
     &   FUNIOF,UNUSED(26),CFNAM(2),CMDNO,MDHED(64,5),BUF(400)
      CHARACTER*12 CNAME
      INCLUDE 'hex80.inc'
      DATA MAXHED/5/,HEDSIZ/64/,MAXFLD/400/
      DATA MISREC/ HEX80 /
C
C
      FLIP=ISMFMT(MDNO)
C      write(6,*)'FLIP= ',FLIP
C      write(6,*)'MDNO= ',MDNO
      IF (MDNO.EQ.CMDNO) GOTO 4
         DO 2 J=1,MAXHED
            IF (MDHED(HEDSIZ,J).EQ.MDNO) GOTO 3
 2       CONTINUE
         GOTO 91
 3       CALL MOVW(HEDSIZ,MDHED(1,J),SNAME)
 4    CONTINUE
      IF (M.LE.0) GOTO 5
      IF (N.LE.0) GOTO 6
C-----DATA RECORD
      IF (M.GT.NR.OR.N.GT.NC) GOTO 7
      POS=DPOS
      NWDS=NDKEYS
      LOC=FDATOF+((M-1)*NC+N-1)*NWDS
      GOTO 8
C-----COLUMN HEADER
 5    IF (N.LE.0.OR.N.GT.NC) GOTO 7
      POS=CPOS
      NWDS=NCKEYS
      LOC=FCHOF+(N-1)*NWDS
      GOTO 8
C-----ROW HEADER
 6    IF (M.GT.NR) GOTO 7
      POS=1
      NWDS=NRKEYS
      LOC=FRHOF+(M-1)*NWDS
      GOTO 8
 7    IF (M.NE.0.OR.N.NE.0) GOTO 91
      POS=1
      NWDS=MAXFLD
      LOC=FUSROF
      GOTO 8
 8    IF (NWDS.LE.0) GOTO 91

      CNAME=' '
      CALL MOVWC(CFNAM,CNAME(1:8))

      III= LWI(CNAME,LOC,1,CHECK)

      IF (CHECK.EQ.MISREC) GOTO 91
      III= LWI(CNAME,LOC,NWDS,ARRAY(POS))
      MDGET=0
      RETURN
 91   MDGET=-1
      RETURN
      END
