      SUBROUTINE POSFIND(IDAY,IRUN,IVAL1,IVAL2,IPOS1,IPOS2)
      CHARACTER*7 CTMP
      CHARACTER*2 CTMP2
C
C  SUBROUTINE POSFIND returns two ADDE dataset positions for a pair
C   of requested days/runs/valid times.  Note that the file containing
C   the information to match-up is a text file generated from GRDLIST
C   command output.
C
C   PARAMETERS:
C
C    IDAY= Date to match GRID files with (I)
C    IRUN= Model run to match GRID files with (I)
C    IVAL1= Valid time #1 to match GRID files with (I)
C    IVAL2= Valid time #2 to match GRID files with (I)
C    IPOS1= Dataset position for first valid time (O)
C    IPOS2= Dataset position for second valid time (O)
C
C  Open text file containing GRDLIST output
C
      OPEN(UNIT=9,FILE='MODLIST',STATUS='OLD')
C
C  Initialize positions to a "fail value" of -9999
C
      IPOS1=-9999
      IPOS2=-9999
C
C  Read in GRDLIST data line by line
C
C!  10  READ(9,20,ERR=10,END=999) IPOSX,IRUNX,IVALX,IDAYX
C!  20  FORMAT(6X,I3,38X,I1,4X,I2,8X,I5)
  10  READ(9,20,ERR=10,END=999) IPOSX,CTMP,IVALX,IDAYX
  20  FORMAT(6X,I3,34X,A7,2X,I2,8X,I5)
C
Cy2k convert IDAYX to 7 digit
      CALL MCYDTOCYD(IDAYX, IDAYX)
C  Because the location of the run is not in the same place in every
C   GRDLIST we can only read in the run time as a character string.
C   The following will locate the run time within the string.
C
      DO 30 J=1,6
        IF(CTMP(J:J+1).EQ.'00') IRUNX=0
        IF(CTMP(J:J+1).EQ.'06') IRUNX=6
        IF(CTMP(J:J+1).EQ.'12') IRUNX=12
        IF(CTMP(J:J+1).EQ.'18') IRUNX=18
  30  CONTINUE
C
C  If run/valid time/day match the requsted values for the first
C   valid time, then set position one to the current position read in.
C
C!!!      WRITE(*,666) IRUN,IRUNX,IVAL1,IVAL2,IVALX,IDAYX,IDAY,IPOSX
C!!! 666  FORMAT(8(I7,1X))
      IF((IRUNX.EQ.IRUN).AND.(IVALX.EQ.IVAL1).AND.
     +(IDAYX.EQ.IDAY)) IPOS1=IPOSX
C
C  If run/valid time/day match the requsted values for the second
C   valid time, then set position two to the current position read in.
C
      IF((IRUNX.EQ.IRUN).AND.(IVALX.EQ.IVAL2).AND.
     +(IDAYX.EQ.IDAY)) IPOS2=IPOSX
      GOTO 10
 999  CLOSE(UNIT=9)
      RETURN
      END
