      SUBROUTINE RADCL8M(TAU,T,KCHAN,R,NSFC)
                                           
C--------------------------------------------------------------------
C 02 Mar 01.. Mods for GOES-M: Replaced call to PLANGO with call
C             to GOESPLAN
C
C INTEGRAL PS TO PC OF TAU*DB
C
C INPUTS
C     TAU = (R) ARRAY OF TRANSMITTANCES FOR MET. CHANNELS
C     T = (R) ARRAY OF OBSERVED BRIGHTNESS TEMPERATURES FOR MET. CHANNELS
C     KCHAN = (I) DESIRED CHANNEL NUMBER (2 OR 3)
C     NSFC = (I) LEVEL NUMBER OF SURFACE
C
C  OUTPUTS
C    R = (R) ARRAY OF RADIANCES FOR MET. CHANNELS
C
C  SUBROUTINES
C     PLANMS(TEMPERATURE,CHANNEL NO)
C        CONVERT METEOSAT TEMPERATURE TO RADIANCE (HMW)
C
C -------------------------------------------------------------------
                                                                     
      DIMENSION TAU(1),T(1),R(1)
      DATA NP/21/
                 
C R(1) CORRESPONDS TO PC=1000MB, AND EQUALS ZERO
      DO 10 I=1,NP
         R(I)=0.
 10   CONTINUE
              
      SUM=0.
      B1=GOESPLAN(T(NSFC),KCHAN)
      TAU1=TAU(NSFC)
      NSFCP1=NSFC+1
      DO 20 I=NSFCP1,NP
         B2=GOESPLAN(T(I),KCHAN)
         TAU2=TAU(I)
         SUM=SUM+.5*(TAU1+TAU2)*(B2-B1)
         B1=B2
         TAU1=TAU2
         R(I)=SUM
 20   CONTINUE
              
      RETURN
      END
