      FUNCTION STANAT(MODIN, GIVEN, MODOUT)                  
C     TO INTER-CONVERT AMONG ATMOSPHERIC VARIABLES WITHIN THE                   
C     STANDARD ATMOSPHERE.  THE VALUES MODIN AND MODOUT DETERMINE               
C     THE INPUT AND OUTPUT, WITH 'GIVEN' AS THE GIVEN ARGUMENT.                 
C     MODIN AND MODOUT ARE AS FOLLOWS                                           
C                                                                               
C       1.  HEIGHT IN METERS                                                    
C       2.  PRESSURE IN MILLIBARS                                               
C       3.  TEMPERATURE IN CELSIUS                                              
C                                                                               
C     FOR EXAMPLE, TO GET TEMPERATURE, GIVEN A PRESSURE OF 200 MB,              
C     USE:                                                                      
C                                                                               
C        TEMP = STANAT(2, 200., 3)                                              
C                                                                               
      COMMON/TQB/TQBUF(33)                                                      
C                                                                               
      ARG = GIVEN                                                               
      GO TO (10,20,30), MODIN                                                   
C                                                                               
C     INPUT IS HEIGHT                                                           
10    GO TO (900, 300, 200),MODOUT                                              
C                                                                               
C     INPUT IS PRESSURE                                                         
20    IF(ARG .LT. .04244) GO TO 980                                             
      GO TO (400, 900, 100), MODOUT                                             
C                                                                               
C     INPUT IS TEMPERATURE                                                      
30    GO TO (700,700,900),MODOUT                                                
C                                                                               
C     GET TEMPERATURE GIVEN PRESSURE                                            
100   IF(ARG .GT. 234.53) GO TO 190                                             
      IF(ARG .GT. 8.421) GO TO 280                                              
      IF(ARG .GT. .9282) GO TO 170                                              
      IF(ARG .GT. .3498) GO TO 160                                              
      IF(ARG .GT. .04244) GO TO 150                                             
      R = -33.16                                                                
      GO TO 902                                                                 
C                                                                               
150   R = 350.*(ARG/.3498)**.1788742 - 273.16                                   
      GO TO 902                                                                 
C                                                                               
160   R = 76.84                                                                 
      GO TO 902                                                                 
C                                                                               
170   R = 218.*(ARG/8.421)**(-.2146881) - 273.                                  
      GO TO 902                                                                 
C                                                                               
190   ARG = 44307.69*(1. - (ARG/1013.25)**.1902588)                             
      GO TO 290                                                                 
C     CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC        
C                                                                               
C     TEMPERATURE GIVEN HEIGHT                                                  
200   IF(ARG .LE. 10769.) GO TO 290                                             
      IF(ARG .LE. 32000.) GO TO 280                                             
      IF(ARG .LE. 50000.) GO TO 270                                             
      IF(ARG .LE. 60000.) GO TO 260                                             
      IF(ARG .LE. 78000.) GO TO 250                                             
C                                                                               
240   R = -33.16                                                                
      GO TO 902                                                                 
C                                                                               
250   R = 76.84 - .00611111*(ARG - 60000.)                                      
      GO TO 902                                                                 
C                                                                               
260   R = 76.84                                                                 
      GO TO 902                                                                 
C                                                                               
270   R = -55. + .007333333*(ARG - 32000.)                                      
      GO TO 902                                                                 
C                                                                               
280   R = -55.                                                                  
      GO TO 902                                                                 
C                                                                               
290   R = 15. - .0065*ARG                                                       
      GO TO 902                                                                 
C     CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC          
C                                                                               
C     PRESSURE GIVEN HEIGHT                                                     
300   IF(ARG .LT. 10769.) GO TO 390                                             
      IF(ARG .LT. 32000.) GO TO 380                                             
      IF(ARG .LT. 50000.) GO TO 370                                             
      IF(ARG .LT. 60000.) GO TO 360                                             
      IF(ARG .LE. 78000.) GO TO 350                                             
C                                                                               
      R = 0.                                                                    
      GO TO 902                                                                 
C                                                                               
350   T = 350. - .00611111*(ARG - 60000.)                                       
      R = .3498*(T/350.) ** 5.590518                                            
      GO TO 902                                                                 
C                                                                               
360   R = .9282*EXP(-.0000975886*(ARG - 50000.))                                
      GO TO 902                                                                 
C                                                                               
370   T = 218. + .00733333*(ARG - 32000.)                                       
      R = 8.421*(T/218.) ** (-4.65792)                                          
      GO TO 902                                                                 
C                                                                               
380   R = 234.53*EXP(-.000156698*(ARG - 10769.))                                
      GO TO 902                                                                 
C                                                                               
390   T = 288. - .0065*ARG                                                      
      R = 1013.25 * (T/288.) ** 5.2549964                                       
      GO TO 902                                                                 
C     CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC          
C                                                                               
C     HEIGHT GIVEN PRESSURE                                                     
400   IF(ARG .GT. 251.378) GO TO 490                                            
      IF(ARG .GT. 8.421) GO TO 480                                              
      IF(ARG .GT. .9282) GO TO 470                                              
      IF(ARG .GT. .3498) GO TO 460                                              
      IF(ARG .GT. .04244) GO TO 450                                             
C                                                                               
      R = 78000. - ALOG(ARG/.04244)/.000140904                                  
      GO TO 902                                                                 
C                                                                               
450   R = -(ARG**.1788742 - .8287072)/.00001446949 + 60000.                     
      GO TO 902                                                                 
C                                                                               
460   R = 50000. + ALOG(.9282/ARG)/9.758857E-5                                  
      GO TO 902                                                                 
C                                                                               
470   R = (ARG**(-.2146881) - .6329005)/2.129023E-5 + 32000.                    
      GO TO 902                                                                 
C                                                                               
480   R = 10769. + ALOG(234.53/ARG) * 6381.702                                  
      GO TO 902                                                                 
C                                                                               
490   R = 44307.69*(1. - (ARG/1013.25)**.1902588)                               
      GO TO 902                                                                 
C                                                                               
C     HEIGHT OR PRESSURE GIVEN TEMP                                             
700   IF(ARG .GT. 100.) ARG = ARG - 273.16                                      
      IF(ARG .LT. -55.) GO TO 990                                               
      R = (15. - ARG)/.0065                                                     
      IF(MODOUT .EQ. 1) GO TO 902                                               
      GO TO 300                                                                 
C                                                                               
C     TRIVIAL CASE, MODIN = MODOUT                                              
900   R = ARG                                                                   
C                                                                               
902   STANAT = R                                                                
      RETURN                                                                    
C                                                                               
980   CALL SDEST( '(132X, T3,                                                  
     1  "PRESS ARG ",E12.4," IS INVALID (LESS THAN .04244) IN STANAT"           
     2 /)', TQBUF, ARG)                                                         
      RETURN                                                                    
C                                                                               
990   CALL SDEST('(132X,T3,"INVALID TEMP GIVEN TO STANAT ",F10.1/)',           
     1  TQBUF,  ARG)                                                            
      RETURN                                                                    
      END                                                                       
